<template>
  <div class="wrapper" style="overflow: hidden">
    <div id="header">
      <div id="headTitle">
        <Logo/>

        <h1 id="title" _msttexthash="48503" _msthash="2">{{i18ntext.lngText('recept_order')}}</h1>
      </div>
      <Header />
      <ol id="topicPath">
        <li style="margin-left: 317px">
          <router-link to="menupurchase"
            ><a href="dashbaord">
              <font style="vertical-align: inherit">
                <font style="vertical-align: inherit">{{i18ntext.lngText('recept_order')}}</font>
              </font>
            </a>
          </router-link>
        </li>
      </ol>
      <!-- / #header -->
    </div>
    <div class="search-box">
      <div id="purchase">
        <!--#contents -->
        <div class="search-box mb-4">
          <div class="search-box-title" id="Bars">
            <div id="bar" style="width: 90%">
              <a
                class="btn-radius bt-pn btn btn-sm"
                href="#"
                data-bs-toggle="modal"
                data-bs-target="#staticBackdropss"
                id="bar-1"
                tabindex="10028"
                style="float: left"
              >
                <i class="fas fa-plus" style="padding-right: 5px; margin-top: -2px"> </i>
                {{i18ntext.lngText('add_new')}}
              </a>
              <router-link to="/viewrecept"
                ><a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fas fa-eye" style="padding-right: 5px"> </i>
                  {{i18ntext.lngText('view')}}
                </a></router-link
              >
            </div>
            <div id="right" style="width: 10%">
              <a
                class="btn-radius bt-pn btn btn-sm"
                data-bs-toggle="dropdown"
                aria-expanded="false"
                style="float: right; color: #f8f5b4; margin-right: 11px; margin-top: -2px"
              >
                <i class="fas fa-plus" style="padding-right: 5px"> </i>
                {{i18ntext.lngText('menu')}}
              </a>
              <ul class="dropdown-menu">
                <li v-if="!isOpen">
                  <button
                    class="dropdown-item btn btn-primary"
                    tabindex="10028"
                    @click="saverecept()"
                  >
                    <i class="fas fa-edit"></i> {{i18ntext.lngText('recept')}}
                  </button>
                </li>

                <li>
                  <a
                    class="dropdown-item"
                    data-bs-toggle="modal"
                    data-bs-target="#staticboomId"
                    tabindex="10028"
                    href="#"
                    ><i class="fa fa-print" aria-hidden="true"></i> {{i18ntext.lngText('print')}}</a
                  >
                </li>
              </ul>
            </div>
          </div>
          <div
            class="modal fade ui-modal"
            id="staticBackdrop"
            data-bs-backdrop="static"
            data-bs-keyboard="false"
            tabindex="-1"
            aria-labelledby="staticBackdropLabel"
            aria-hidden="true"
          >
            <div class="modal-dialog">
              <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                  <h5 class="modal-title" id="staticBackdropLabel">
                    <span
                      class="ui-dialog-title"
                      id="ui-dialog-title-modal-edit-dialog"
                      >{{ this.title }}</span
                    >
                  </h5>
                  <span
                    class="ui-icon ui-icon-closethick"
                    data-bs-dismiss="modal"
                    aria-label="Close"
                  ></span>
                </div>
                <div class="ui-dialog-content">
                  <div class="modal-body">
                    {{ this.message }}
                  </div>
                  <div class="modal-footer">
                    <div
                      class="button type2"
                      id="uniform-undefined"
                      data-bs-dismiss="modal"
                    >
                      <span
                        >{{i18ntext.lngText('No')}}<input autocomplete="off"
                          type="button"
                          class="type2"
                          value="No"
                          style="width: 89px; opacity: 0"
                          onclick="edit_cancel()"
                          tabindex="10008"
                      /></span>
                    </div>
                    <div
                      class="button type2"
                      @click="messagegetconfirm(this.confirm)"
                      data-bs-dismiss="modal"
                    >
                      <span>{{i18ntext.lngText('yes')}}</span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="search-box-content search-box02">
            <table
              width="100%"
              border="0"
              cellpadding="0"
              cellspacing="0"
              class="tbl_search"
            >
              <tbody>
                <tr>
                  <th width="20%">{{i18ntext.lngText('document_no')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="form.document_no"
                      class="string_zen_kana clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />
                  </td>
                </tr>
                <tr>
                  <th width="20%">{{i18ntext.lngText('document_type')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="form.document_type"
                      class="string_zen_kana clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />
                  </td>
                </tr>
                <tr>
                  <th width="20%">{{i18ntext.lngText('description')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="form.description"
                      class="string_zen clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />
                  </td>
                </tr>
                <tr>
                  <th width="20%">{{i18ntext.lngText('supplier')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="form.suppliyer_code"
                      class="string_zen clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />

                  </td>
                </tr>

                <tr>
                  <th width="20%">{{i18ntext.lngText('total_amount')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      :value="Number(form.total_amount).toLocaleString()"
                      class="string_zen clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />

                  </td>
                </tr>

                <tr>
                  <th width="20%">{{i18ntext.lngText('currency')}}</th>
                  <td width="80%">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="form.curency_code"
                      class="string_zen clear_text text input_text"
                      style="width: 380px"
                      type="text"
                    />
                  </td>
                </tr>


              </tbody>
            </table>
          </div>
        </div>
        <div class="box">
          <div class="box-content">
            <table
              width="100%"
              border="0"
              cellpadding="0"
              cellspacing="0"
              class="tbl_list"
            >
              <thead>
                <tr>
                  <th style="width: 7%">{{i18ntext.lngText('product_no')}}</th>
                  <th style="width: 10%">{{i18ntext.lngText('description')}}</th>
                  <th style="width: 7%">{{i18ntext.lngText('qty_order')}}</th>
                  <th style="width: 7%">{{i18ntext.lngText('qty_recept')}}</th>
                  <th style="width: 7%">{{i18ntext.lngText('unittype')}}</th>
                  <th style="width: 7%">{{i18ntext.lngText('buy_price')}}</th>
                  <!-- <th style="width: 7%">{{i18ntext.lngText('currency')}}</th> -->
                  <th style="width: 7%">{{i18ntext.lngText('balance')}}</th>
                  <th style="width: 7%">{{i18ntext.lngText('total_amount')}}</th>
                  <!-- <th style="width: 7%">Issu Date</th> -->
                  <th style="width: 7%">{{i18ntext.lngText('expire')}}</th>
                </tr>
                <tr v-for="purchaseLine in purchases_lines" :key="purchaseLine.index">
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.product_no"
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.description"
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.inventory"
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      v-model="purchaseLine.inventory_recetive"
                      :disabled="isOpen"
                      @change="ExpireUpdateList(purchaseLine)"
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.unit_of_measure_code"
                      
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="isOpen"
                      v-model="purchaseLine.unit_price"
                      @change="ExpireUpdateList(purchaseLine)"
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th>

                  <!-- <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.curency_code"
                      
                      class="clear_text code text"
                      style="width: 100%"
                    />
                  </th> -->
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      v-model="purchaseLine.qty_balance"
                      class="clear_text code text"
                      id="jusinsya_code"
                      type="text"
                      tabindex="10008"
                      style="width: 100%"
                    />
                  </th>
                  <th style="padding: 10px">
                    <input autocomplete="off"
                      :disabled="true"
                      :value="Number(purchaseLine.total_amount).toLocaleString()"
                      class="clear_text code text"
                      id="jusinsya_code"
                      type="text"
                      tabindex="10008"
                      style="width: 100%"
                    />
                  </th>

                  <th style="padding: 10px">
                    <input autocomplete="off"
                    :disabled="isOpen"
                      type="date"
                      v-model="purchaseLine.exprit_date"
                      @change="updateExpireDate(purchaseLine)"
                      class="clear_text code text"
                      id="jusinsya_code"
                      tabindex="10008"
                    />
                  </th>
                </tr>
              </thead>
              <vue-countdown
                style="display: none"
                v-if="counting"
                :time="60000"
                @end="onCountdownEnd"
                v-slot="{ totalSeconds }"
                >Fetch again {{ totalSeconds }} seconds later</vue-countdown
              >
            </table>
          </div>
          <div class="box-footer-pagination">
            <div class="pagination" style="padding: 10px; width: 100%">
              <div
                class="button type2"
                id="uniform-undefined"
                v-show="btnGenerate"
                @click="myFunction()"
                style="float: left"
              >
                <span style="width: 150px"
                  ><input autocomplete="off"
                    type="button"
                    class="type2"
                    tabindex="10025"
                    value="display"
                    style="opacity: 0; width: 54px"
                  /><i class="fas fa-plus"></i> {{i18ntext.lngText('generate')}}</span
                >
              </div>
              <div style="width: 30%; float: right; background: none; color: #f8f5b4">
                <!-- /.card-header -->
                <div
                  id="inspection_call_statusdisplay"
                  class="clearfix mt_0"
                  style="margin=0;"
                >
                  <div class="col main status_tested" style="border: none; width: 100%">
                    <table cellpadding="0" cellspacing="0" border="0">
                      <thead>
                        <tr></tr>
                      </thead>
                      <tbody>
                        <tr>
                          <th>
                            <font style="vertical-align: inherit; color: #f8f5b4"
                              >{{i18ntext.lngText('product')}}</font
                            >
                          </th>
                          <td>
                            <input autocomplete="off"
                              style="
                                vertical-align: inherit;
                                background: none;
                                border: none;
                              "
                              :value="Number(purchases_lines.length).toLocaleString()"
                            />
                          </td>
                        </tr>
                        <tr>
                          <th>
                            <font style="vertical-align: inherit; color: #f8f5b4"
                              >{{i18ntext.lngText('item')}}</font
                            >
                          </th>
                          <td>
                            <input autocomplete="off"
                              style="
                                vertical-align: inherit;
                                background: none;
                                border: none;
                              "
                              :value="Number(totalProduct).toLocaleString()"
                            />
                          </td>
                        </tr>

                        <tr>
                          <th>
                            <font style="vertical-align: inherit; color: #f8f5b4"
                              >{{i18ntext.lngText('total_amount')}}</font
                            >
                          </th>
                          <td>
                            <input autocomplete="off"
                              style="
                                vertical-align: inherit;
                                background: none;
                                border: none;
                              "
                              :value="Number(totalAmount).toLocaleString()"
                            />
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div
    class="modal fade ui-modal"
    id="staticboomId"
    data-bs-backdrop="static"
    data-bs-keyboard="false"
    tabindex="-1"
    aria-labelledby="staticboomId"
    aria-hidden="true"
  >
    <div class="modal-dialog" id="recept">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> {{i18ntext.lngText('print')}}
          </h5>
          <span
            class="ui-icon ui-icon-closethick"
            data-bs-dismiss="modal"
            aria-label="Close"
          ></span>
        </div>
        <div class="ui-dialog-content" id="purchaseorder">
          <div class="card">
            <div class="card-body">
              <div class="mt-3 print-size">
                <div style="padding: 0 50px">
                  <div class="col-md-12">
                    <div class="text-center">
                      <h3 class="title-purchase">{{i18ntext.lngText('report')}} {{i18ntext.lngText('recept_order')}}</h3>
                    </div>
                  </div>
                  <div class="col-container">
                    <div class="col1">
                      <p class="p-bg font-size p-pad">{{i18ntext.lngText('company')}}</p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('name')}} :</span>
                        <span id="fon">{{ company.company_name }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('phonenumber')}} :</span>
                        <span id="fon">{{ company.company_Phone }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('email')}} :</span>
                        <span id="fon">{{ company.company_Email }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{i18ntext.lngText('address')}} :</span>
                        <span id="fon">{{ company.company_Address }}</span>
                      </p>
                    </div>
                    <div class="col2">
                      <p class="text-center p-bg font-size p-pad">{{i18ntext.lngText('date')}}</p>
                      <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                    </div>
                  </div>
                  <div class="my-2 justify-content-center">
                    <table id="pr-tb">
                      <thead>
                        <tr class="p-bg">
                          <th class="text-center">{{i18ntext.lngText('product_no')}}</th>
                          <th class="text-center">{{i18ntext.lngText('description')}}</th>
                          <th class="text-center">{{i18ntext.lngText('qty_order')}}</th>
                          <th class="text-center">{{i18ntext.lngText('qty_recept')}}</th>
                          <!-- <th class="text-center">{{i18ntext.lngText('unittype')}}</th> -->
                          <th class="text-center">{{i18ntext.lngText('price')}}</th>
                          <!-- <th class="text-center">{{i18ntext.lngText('currency')}}</th> -->
                          <th class="text-center">{{i18ntext.lngText('balance')}}</th>
                          <th class="text-center">{{i18ntext.lngText('total')}}</th>
                          <th class="text-center">{{i18ntext.lngText('expire')}}</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr
                          v-for="purchaseLine in purchases_lines"
                          :key="purchaseLine.index"
                        >
                          <td>{{ purchaseLine.document_no }}</td>
                          <td>{{ purchaseLine.description }}</td>
                          <td>
                            {{ Number(purchaseLine.inventory_order).toLocaleString() }} {{ purchaseLine.unit_of_measure_code }}
                          </td>
                          <td>
                            {{ Number(purchaseLine.inventory_recetive).toLocaleString() }} {{ purchaseLine.unit_of_measure_code }}
                          </td>
                          <td>{{ Number(purchaseLine.unit_price).toLocaleString() }} ៛</td>
                          <td>{{ Number(purchaseLine.qty_balance).toLocaleString() }} {{ purchaseLine.unit_of_measure_code }}</td>
                          <td>
                            {{ Number(purchaseLine.total_amount).toLocaleString() }} ៛
                          </td>
                          <td v-if="purchaseLine.exprit_date != null">{{ formatdatetime(purchaseLine.exprit_date) }}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <a
            v-print="'#purchaseorder'"
            class="btn-purchase btn-light text-capitalize border-0"
            data-mdb-ripple-color="dark"
            ><i class="fas fa-print text-primary"></i> {{i18ntext.lngText('print')}}</a
          >
        </div>
      </div>
    </div>
  </div>

  <div id="myModal" class="lskymodal">
      <div class="lskymodal-content">
        <p><i class="fa fa-check" aria-hidden="true"></i> {{ message }}</p>
      </div>
    </div>
  <Footer/>
  <UserInfo/>
</template>

<script>
import axios, { Axios } from "axios";
import Auth from "../../auth/Auth";
import Header from "../Header.vue";
import moment from "moment";
import print from "vue3-print-nb";
import i18n from "../../i18n/i18n";
import UserInfo from "../UserInfo.vue";
import Footer from "../footer.vue";
import Logo from "../logo.vue"

export default {
  components: { Header,UserInfo, Footer,Logo },
  directives: { print },
  data() {
    return {
      i18ntext: i18n,
      total: 0,
      productline: 0,
      company: [],
      dateformart: "",
      purchases: [],
      purchases_lines: [],
      form: {
        document_no: "",
        document_type: "",
        description: "",
        suppliyer_code: "",
        curency_code: "",
        inactived: "",
        total_amount: 0,
        created_by: "",
        statue: "",
        delete_by: "",
      },
      message : '',
      purchas: "",
      datetime: new Date(),
    };
  },
  mounted() {
    if (Auth.check()) {
        if(!Auth.checkPermission(' RESCEPTORDER_ALL')){
            this.$router.push('/dashboard');
        }
    }
    try {
      if (this.$route.query.id.trim() != "undefined") {
        this.purchas = this.$route.query.id;
      }
    } catch (error) {
      this.purchas = "undefined";
    }
    this.getEdit();
    this.getPurchase();
    this.getsuppliyer();
    this.getcompany();
  },
  computed:{
    totalAmount(){
      let total = 0
      this.purchases_lines.forEach(el => {
        total += parseFloat(el.total_amount)
      })
      this.form.total_amount = total
      axios.post('api/v1/purchase/update/purchaseorder/'+this.form.document_no,this.form)
            .then(res => {
              console.log('save successfully')
            })
      return total
    },
    totalProduct(){
      let item = 0
      this.purchases_lines.forEach(el => {
        if(el.inventory_recetive == null ) el.inventory_recetive = 0
        item += parseFloat(el.inventory_recetive)
      })
      return item
    },
    isOpen(){
      return this.form.statue === 'pending' ? false : true
    },
    isHaveExpireDate(){
      let isTrue = false
      this.purchases_lines.forEach(el => {
        if(el.exprit_date == null){ isTrue = true }
      })
      return isTrue
    }

  },
  methods: {
    async messagebox() {
      var modal = document.getElementById("myModal");
      modal.style.display = "block";
      setTimeout(() => (modal.style.display = "none"), 2000);
    },
    getPurchase() {
      axios.get("api/v1/receive/getpurchea").then((response) => {
        this.purchases = response.data;
      });
    },
    getcompany() {
      axios.get("/api/v1/getSetup").then((response) => {
        this.company = response.data;
        this.dateformart = moment(new Date()).format("DD-MM-YYYY");
      });
    },
    getsuppliyer() {
      axios.get("/api/v1/suppliyers/getdatasub").then((response) => {
        this.suppliyer = response.data;
      });
    },
    getEdit() {
      this.purchas = this.$route.query.id
   
        axios.get("api/v1/purchase/edit/purchaseorder/" + this.purchas)
          .then((response) => {
            this.form = response.data;
          });

        axios.get("api/v1/purchase/edit/purchaseline/" + this.purchas)
          .then((response) => {
            this.purchases_lines = response.data;
            this.purchases_lines.forEach(el => {
              if(el.inventory_recetive == null) el.inventory_recetive = 0
              el.total_amount = parseFloat(el.inventory_recetive) * parseFloat(el.unit_price)
            })
           
          });

    },
    btnDelete(id) {
      axios.post("api/v1/purchase/delete/purchaseorder/" + id).then((res) => {
        this.getPurchase();
      });
    },
    saverecept() {
      if(!this.isHaveExpireDate){
          axios.post("api/v1/receive/recept", this.form).then((res) => {
          console.log(res.data);
          let id = res.data[0].id
          if (res.data.statue == "successful") {
            this.purchases_lines.forEach((element) => {
              element.resId = id
              axios.post("api/v1/receive/receptlink", element).then((res) => {
                console.log(res.data);
                  this.message = "Recieve successfully"
                  this.messagebox()
                  this.getEdit();
              });
            });
          }
          
        });
        
      }
      else{
        alert("Product don't have expire date please select expire date first before save")
      }

     
    },
    formatdatetime(dateform) {
            try {
                return  moment(dateform).format('DD-MM-YYYY');
            } catch (error) {
                return dateform;
            }
        },

    ExpireUpdateList(item) {
        item.qty_balance = parseFloat(item.inventory_recetive) - parseFloat(item.inventory)
       if (item.inventory_recetived == null){item.inventory_recetived =0;} 
       if (item.inventory_order == null || item.inventory_order == "" || item.inventory_order == 0){item.inventory_order = item.inventory} 
       item.inventory_recetived = (parseFloat(item.inventory_order) - parseFloat(item.inventory) ) + parseFloat(item.inventory_recetive)
        if(item.qty_balance < 0) item.qty_balance = 0
        item.inventory_recetive = parseFloat(item.inventory_recetive) - parseFloat(item.qty_balance)
        item.total_amount = parseFloat(item.inventory_recetive) * parseFloat(item.unit_price)

        axios.post("api/v1/purchase/update/purchaseline/" + item.document_no, item)
             .then((res) => {
              console.log(res.data)
           });
    },
    updateExpireDate(item){
      let itemDate = new Date(item.exprit_date)
      let today = new Date();
      if(itemDate.getTime() > today.getTime()){
        axios.post("api/v1/purchase/update/purchaseline/" + item.document_no, item)
             .then((res) => {
              console.log(res.data)
           });
      }
      else{
        alert("expire date must bigger that today")
        item.exprit_date = null
      }
    }
  },
};
</script>
